<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_MAIL")) return;
define("_ECRIRE_INC_MAIL", "1");


//
// Chez lyconiania, envoyer un mail coupe la connection MySQL (sic)
//

$GLOBALS['queue_mails'] = '';

function envoyer_queue_mails() {
	global $queue_mails;
	if (!$queue_mails) return;
	reset($queue_mails);
	while (list(, $val) = each($queue_mails)) {
		$email = $val['email'];
		$sujet = $val['sujet'];
		$texte = $val['texte'];
		$headers = $val['headers'];
		@mail($email, $sujet, $texte, $headers);
	}
}

if ($GLOBALS['hebergeur'] == 'lycos') {
	register_shutdown_function(envoyer_queue_mails);
}

function tester_mail() {
	global $hebergeur;
	$test_mail = true;
	if ($hebergeur == 'free') $test_mail = false;
	return $test_mail;
}

function envoyer_mail($email, $sujet, $texte, $from = "", $headers = "") {
	global $hebergeur, $queue_mails, $flag_wordwrap, $os_serveur;
	include_ecrire("inc_filtres.php3");

	if (!$from) $from = $email;
	if (!email_valide($email)) return false;
	if ($email == _T('info_mail_fournisseur')) return false;

	spip_log("mail ($email): $sujet");

	$charset = lire_meta('charset');

	$headers = "From: $from\n".
		"MIME-Version: 1.0\n".
		"Content-Type: text/plain; charset=$charset\n".
		"Content-Transfer-Encoding: 8bit\n$headers";

	$texte = filtrer_entites($texte);
	$sujet = filtrer_entites($sujet);

	// encoder le sujet si possible selon la RFC
	if($GLOBALS['flag_multibyte'] AND @mb_internal_encoding($charset))
		$sujet = mb_encode_mimeheader($sujet, $charset, 'Q');

	if ($flag_wordwrap) $texte = wordwrap($texte);

	if ($os_serveur == 'windows') {
		$texte = ereg_replace ("\r*\n","\r\n", $texte);
		$headers = ereg_replace ("\r*\n","\r\n", $headers);
	}

	switch($hebergeur) {
	case 'lycos':
		$queue_mails[] = array(
			'email' => $email,
			'sujet' => $sujet,
			'texte' => $texte,
			'headers' => $headers);
		return true;
	case 'free':
		return false;
	case 'online':
		return @email('webmaster', $email, $sujet, $texte);
//	nexen annonce la fin de ses particularismes (23/01/2003)
//	case 'nexenservices':
//		return @email($email, $sujet, $texte, $headers);
	default:
		return @mail($email, $sujet, $texte, $headers);
	}
}

function extrait_article($row) {
	include_ecrire("inc_texte.php3");
	include_ecrire("inc_filtres.php3");

	$adresse_site = lire_meta("adresse_site");

	$id_article = $row[0];
	$titre = $row[2];
	$chapo = $row[6];
	$texte = $row[7];
	$date = $row[9];
	$statut = $row[10];

	$les_auteurs = "";
 	$query = "SELECT auteurs.* FROM spip_auteurs AS auteurs, spip_auteurs_articles AS lien WHERE lien.id_article=$id_article AND auteurs.id_auteur=lien.id_auteur";
	$result_auteurs = spip_query($query);

	while ($row = spip_fetch_array($result_auteurs)) {
		$nom_auteur = $row['nom'];

		if ($les_auteurs) $les_auteurs .= ', ';
		$les_auteurs .= $nom_auteur;
	}

	$extrait = "** $titre **\n";
	if ($les_auteurs) $extrait .= _T('info_les_auteurs_1', array('les_auteurs' => $les_auteurs));
	if ($statut == 'publie') $extrait .= " "._T('date_fmt_nomjour_date', array('nomjour'=>nom_jour($date), 'date'=>affdate($date)));
	$extrait .= "\n\n".textebrut(propre(couper_intro("$chapo<p>$texte", 700)))."\n\n";
	if ($statut == 'publie') $extrait .= "-> ".$adresse_site."/spip_redirect.php3?id_article=$id_article\n\n";
	return $extrait;
}


function nettoyer_titre_email($titre) {
	$titre = ereg_replace("\n", ' ', supprimer_tags($titre));
	return ($titre);
}

function envoyer_mail_publication($id_article) {
	global $connect_nom;
	$adresse_suivi = lire_meta("adresse_suivi");
	$adresse_site = lire_meta("adresse_site");
	$nom_site_spip = lire_meta("nom_site");
	$suivi_edito = lire_meta("suivi_edito");

	if ($suivi_edito == "oui") {
		$query = "SELECT * FROM spip_articles WHERE id_article = $id_article";
		$result = spip_query($query);

		if ($row = spip_fetch_array($result)) {

			// selectionne langue du site
			$lang_utilisateur = $GLOBALS['spip_lang'];
			changer_langue($GLOBALS['langue_site']);

			$titre = nettoyer_titre_email($row['titre']);

			$sujet = _T('info_publie_1', array('nom_site_spip' => $nom_site_spip, 'titre' => $titre));
			$courr = _T('info_publie_2')."\n\n";
			$courr .= _T('info_publie_01', array('titre' => $titre, 'connect_nom' => $connect_nom))."\n\n\n";
			$courr = filtrer_entites($courr) . extrait_article($row);
			envoyer_mail($adresse_suivi, $sujet, $courr);

			// reinstalle la langue utilisateur (au cas ou)
			changer_langue($lang_utilisateur);
		}
	}
}

function envoyer_mail_proposition($id_article) {
	$adresse_suivi = lire_meta("adresse_suivi");
	$adresse_site = lire_meta("adresse_site");
	$nom_site_spip = lire_meta("nom_site");
	$suivi_edito = lire_meta("suivi_edito");

	if ($suivi_edito == "oui") {
		$query = "SELECT * FROM spip_articles WHERE id_article = $id_article";
		$result = spip_query($query);

		if ($row = spip_fetch_array($result)) {
			$lang_utilisateur = $GLOBALS['spip_lang'];
			changer_langue($GLOBALS['langue_site']);

			$titre = nettoyer_titre_email($row['titre']);

			$sujet = _T('info_propose_1', array('nom_site_spip' => $nom_site_spip, 'titre' => $titre));
			$courr = _T('info_propose_2')."\n\n";
			$courr .= _T('info_propose_3', array('titre' => $titre))."\n";
			$courr .= _T('info_propose_4')."\n";
			$courr .= _T('info_propose_5')."\n";
			$courr .= $adresse_site."/ecrire/articles.php3?id_article=$id_article\n\n\n";
			$courr = filtrer_entites($courr) . extrait_article($row);
			envoyer_mail($adresse_suivi, $sujet, $courr);

			changer_langue($lang_utilisateur);
		}
	}
}





function envoyer_mail_piecejointe($email, $sujet, $texte, $from = "", $headers = "", $fichier) {
	global $hebergeur, $queue_mails, $flag_wordwrap, $os_serveur;
	include_ecrire("inc_filtres.php3");

	if (!$from) $from = $email;
	if (!email_valide($email)) return false;
	if ($email == _T('info_mail_fournisseur')) return false;

	spip_log("mail ($email): $sujet");

	$charset = lire_meta('charset');

	$headers = "From: $from\n".
		"MIME-Version: 1.0\n".
		"Content-Type: text/plain; charset=$charset\n".
		"Content-Transfer-Encoding: 8bit\n$headers";

	$texte = filtrer_entites($texte);
	$sujet = filtrer_entites($sujet);

	// encoder le sujet si possible selon la RFC
	if($GLOBALS['flag_multibyte'] AND @mb_internal_encoding($charset))
		$sujet = mb_encode_mimeheader($sujet, $charset, 'Q');

	if ($flag_wordwrap) $texte = wordwrap($texte);

	if ($os_serveur == 'windows') {
		$texte = ereg_replace ("\r*\n","\r\n", $texte);
		$headers = ereg_replace ("\r*\n","\r\n", $headers);
	}

	//si le fichier existe, cration de l'en-tte et insertion du fichier dans une variable 
	if (file_exists("$fichier")) 
	{ 
		$fic = $fichier; 
		$taille = filesize($fic); 
		$type = filetype($fic); 
		 
		//parcours la totalit du fichier  attacher et l'insre dans une variable 
		$PtFicAttache = fopen($fic,"r");  
		$FicDansChaine = fread($PtFicAttache, $taille); 
		fclose($PtFicAttache); 
	
		//encodage en base64 pour que le fichier puisse tre transmissible  travers d'un systme 7-bit, ici un e-mail 
		$fic_attache = base64_encode($FicDansChaine); 
		//scinder la chane en plus petit morceaux, pour se conformer  la RFC 2045 (norme des mails) 
		$fic_attache = chunk_split($fic_attache, 64 , "\r\n"); 
			 
		//Cration de l'en-tte du fichier attach. Attention, les espaces et les \n sont importants !!! 
		$EnteteFicAttache = "\n--some random text\nContent-Type: ".$type.";\n name=\"".$fic."\"\n"."Content-Transfer-Encoding: base64\nContent-Disposition: attachment;\n filename=\"".$fic."\"\n\n"; 
	} 
	
	//sinon, ben on attache rien du tout 
	else 
	{ 
		$fic_attache=""; 
		$EnteteFicAttache=""; 
	} 
	
	//On termine le mail en attachant le fichier et en indiquant l'en-tte du fichier attach 
	$content="--some random text\n\n$texte\n"; 
	$content .= $EnteteFicAttache.$fic_attache; 
	
	//Pour finir, ajouter dans le quatrime paramtre de la fonction mail() ce qui correspond  l'en-tte gnrale du mail 
	//chr(13) est un retour chariot, chr(10) un saut de ligne et chr(9) une tabulation 
	$headers .= "MIME-Version: 1.0\nContent-Type: multipart/mixed;".chr(13).chr(10).chr(9)."boundary=\"some random text\"\n"; 

	$texte=$content;


	switch($hebergeur) {
	case 'lycos':
		$queue_mails[] = array(
			'email' => $email,
			'sujet' => $sujet,
			'texte' => $texte,
			'headers' => $headers);
		return true;
	case 'free':
		return false;
	case 'online':
		return @email('webmaster', $email, $sujet, $texte);
//	nexen annonce la fin de ses particularismes (23/01/2003)
//	case 'nexenservices':
//		return @email($email, $sujet, $texte, $headers);
	default:
		return @mail($email, $sujet, $texte, $headers);
	}
}




?>
